
/* JavaScript content from js/app/config/ServiceRegistryConfig.js in folder common */
/*global define, window */

define("app/config/ServiceRegistryConfig", function () {
  'use strict';

  return {
    GET_PRODUCT_INFORMATION: function (requestObj) {
      return {
        url: "worklight://Product/getProductDetails/1.0.0",
        options : {
          parameters : [
            requestObj.options.id
          ],
          handleAs : "json"
        }
      };
    },
    GET_REVIEWS: function (requestObj) {
      return {
        url: "worklight://Reviews/getReviews/1.0.0",
        options: {
          parameters: [
            requestObj.options.id,
            requestObj.options.resultsPerPage,
            requestObj.options.start,
            requestObj.options.sort
          ],
          handleAs: "json"
        }
      };
    },
    GET_CONTENT: function (requestObj) {
      return {
        url: "worklight://Content/getContent/1.0.0",
        options : {
          parameters : [
            requestObj.options.id
          ],
          handleAs : "json"
        }
      };
    },
    GET_CONTENT_FOR_PRODUCT: function (requestObj) {
      return {
        url: "worklight://Content/getContentforProduct/1.0.0",
        options : {
          parameters : [
            requestObj.options.id,
            requestObj.options.productId
          ],
          handleAs : "json"
        }
      };
    },
    GET_REFINEMENTS: function (requestObj) {
      return {
        url: "worklight://Search/searchForProducts/1.0.0",
        options : {
          parameters : [
            requestObj.options.searchTerm,
            requestObj.options.refinements
          ],
          handleAs: "json"
        }
      };
    }
  };
});