
/* JavaScript content from js/app/controllers/BusyController.js in folder common */
/*global define, window*/

define([
  "dojo/_base/lang",
  "dojo/dom-construct",
  "dojo/dom-class"], function (lang, domConstruct, domClass) {

  var BusyController = function BusyController(promiseOrDeferred, domNode, type, constructMixin) {
    var p = promiseOrDeferred.promise || promiseOrDeferred;

    if (p.then) {
      var e = BusyController.create(domNode, type, constructMixin);

      return p.always(function () {
        BusyController.hide(e);

        setTimeout(function () {
          BusyController.destroy(e);
        }, 100);
      });
    }
    return p;
  };

  BusyController.create = function (domNode, type, constructMixin) {
    var e = domConstruct.create('div', lang.mixin({
      className : "BusyController busy " + type
    }, constructMixin));
    domConstruct.create('div', {
      className : "spinner "
    }, e);

    domConstruct.place(e, domNode, "last");

    return e;
  };

  BusyController.show = function (busyNode) {
    window.getComputedStyle(busyNode).getPropertyValue("height");
    domClass.add(busyNode, "shown");
  };

  BusyController.hide = function (busyNode) {
    domClass.remove(busyNode, "shown");
  };

  BusyController.destroy = function (busyNode) {
    domConstruct.destroy(busyNode);
  };

  return BusyController;

});