
/* JavaScript content from js/app/controllers/NavigationController.js in folder common */
/*global define*/

define("app/controllers/NavigationController", ["dojo/_base/lang",
    "dojo/_base/declare",
    "dojox/mobile/TransitionEvent",
    "dojo/on",
    "dojox/app/Controller"],
    function (lang, declare, TransitionEvent, on, Controller) {
    return declare("NavigationController", Controller, {
      constructor: function () {
        on(document.body, 'app-navigate', lang.hitch(this, this.handleNativeNavigate));
      },
      handleNativeNavigate: function (event) {
        if (!this.app.views[event.viewId]) { throw "view not known: " + event.viewId; }

        var transOpts = {
          target: event.viewId,
          params: event.params
        };

        new TransitionEvent(this.app.domNode, transOpts, event).dispatch();
      }
    });
  });