
/* JavaScript content from js/app/dojoInit.js in folder common */
/*global window*/

/**
 * Creates a new dojox/app and notifies the document when the app has loaded
 * @module app/dojoInit
 *
 * @tutorial {@link https://dojotoolkit.org/reference-guide/1.9/dojox/app.html | dojo/text!app/config}
 *
 * @requires {@link https://dojotoolkit.org/reference-guide/1.9/dojox/app/main.html | dojox/app/main}
 * @requires {@link https://dojotoolkit.org/reference-guide/1.9/dojox/json/ref.html | dojox/json/ref}
 * @requires {@link js/app/config.json}
 * @requires {@link http://dojotoolkit.org/reference-guide/1.9/dojo/on.html | dojo/on}
*/

function dojoInit() {
  require([
    "dojox/app/main",
    "dojox/json/ref",
    "dojo/text!app/config.json",
    "dojo/on",
    "app/util/requestProvider/WorklightRequestProvider"
  ], function (dojoxAppMain, json, config, on) {
    dojoxAppMain(json.fromJson(config));
    window.DOJOX_APP_LOADED = true;
    on.emit(document.body, 'dojox-app-loaded', {});
  });
}

/**
 * Function to run dojoInit() when Worklight is running
*/

function wlCommonInit() {
  dojoInit();
}