
/* JavaScript content from js/app/errors/mapping.js in folder common */
/*global define*/

define("app/errors/mapping", [
  "dojo/_base/declare"],
  function (declare) {
    var Mapping = declare("app/errors/mapping", [], {
      errors: function(error) {
        var statusCode = error.statusCode,
          errorCode = error.errors[3],
          errorKey = error.errors[6];
          
		  var defaultError = function(errorsArray) {
			  return errorsArray[7] !== undefined ? errorsArray[7].replace("msg:","") : "Sorry, we've encountered some unexpected problems. Please try again later."
		  }

        if (statusCode === "400") {
          if (errorCode === "0020" && errorKey === "key:_ERR_LOGONID_ALREDY_EXIST") {
            return {
              message: "You are already registered with this email address.  Please sign in with your email address or tap the 'Forgot your password' link",
              fields: ["email", "confirmEmail"]
            };
          } else if (errorCode === "0004" && errorKey === "key:_ERR_CMD_INVALID_PARAM") {
            return {
              message: "The postcode entered is invalid. Please enter a different postcode",
              field: ["postcode"]
            };
          } else if (errorCode === "9999" && errorKey === "key:_ERR_PASSWORD_EXPIRED") {
	          return {
	          	message: "You are required to update your temporary password. Please go to <a href='homebase://openlink/browser?url=http://www.homebase.co.uk' class='underline'>Homebase.co.uk</a> and visit My Account.</a>"
	          
	          }
          } else {
	          return {
		          message: defaultError(error.errors)
	          }
          }
        } else if (statusCode === "500") {
          return {
            message: "Something went wrong. Please try again"
          };
        } else if (statusCode === "401") {
          if (errorCode === "0023" || errorCode === "0001" && errorKey === "key:_ERR_AUTHENTICATION_ERROR") {
            return {
              message: "Your email address or password are incorrect"
            };
          } else {
	          return {
		          message: defaultError(error.errors)
	          }
          }
        } else if (statusCode === "503") {
          return {
            message: "There was an error logging you in. Please try again"
          };
        } else {        
	        return {
		          message: defaultError(error.errors)
	          }
         }

      }
    });

    return new Mapping();
  });