
/* JavaScript content from js/app/models/Selection.js in folder common */
/*global define*/

define("app/models/Selection", [
  "dojo/_base/lang",
  "dojo/_base/array",
  "dojo/Evented",
  "dojo/Stateful",
  "dojo/_base/declare",
  "app/models/selectionDescription"],
  function (lang, array, Evented, Stateful, declare, selectionDescription) {
    var Selection = declare("app/models/Selection", [Evented, Stateful], {
      lookup: {},
      isSelected: function (refinement) {
        return !!this.lookup[refinement.id()];
      },
      deselect: function (refinement) {
        var originallySelected = this.isSelected(refinement);
        delete this.lookup[refinement.id()];
        if (originallySelected) {
          this.emit('selection-change', refinement, false);
          this.__childSelectionChange__(refinement.parent);
        }
      },
      deselectPrice: function (refinement) {
        this.set('price', undefined);
        this.emit('selection-change', refinement, false);
      },
      select: function (refinement) {
        var originallySelected = this.isSelected(refinement);
        this.lookup[refinement.id()] = true;
        if (!originallySelected) {
          this.emit('selection-change', refinement, true);
          this.__childSelectionChange__(refinement.parent);
        }
      },
      __childSelectionChange__: function (refinement) {
        if (!refinement) return;
        selection.emit('child-selection-change', refinement);
        this.__childSelectionChange__(refinement.parent);
      },
      serialize: function () {
        return {
          lookup: this.lookup,
          price: this.price,
          isDefault: this.isDefault
        };
      },
      restore: function (serializedState) {
        this.lookup = serializedState.lookup;
        if (serializedState.price && (serializedState.price.min !== null || serializedState.price.max !== null)) {
          this.price = serializedState.price;
        }
      }
    });

    // a singleton
    var selection = new Selection();

    return selection;
  });
