
/* JavaScript content from js/app/models/searchOptions.js in folder common */
/*global define*/

define("app/models/searchOptions",
["app/models/Selection"], function (selection) {
  function levelOneSelection(rootRefinement) {
    var selection = [];

    rootRefinement.refinements.forEach(function (refinement) {
      if (refinement.hasSubSelection()) {
        selection.push(refinement);
      }
    });

    return selection;
  }

  return {
    build: function (rootRefinement, categoryId) {

      var selection = levelOneSelection(rootRefinement),
        options = { selectedParameters: [] },
        self = this;

      selection.forEach(function (r) {
        var extractor = self.extractors[r.name];
        if (extractor !== undefined) {
          if (r.name === "ParentCatalogGroup" && categoryId) {
            return;
          }
          extractor(r, options);
        } else {
          extractor = self.extractors.All;
          extractor(r, options);
        }
      }.bind(this));

      options.facet = [];

      options.selectedParameters.forEach(function(p) {
        options.facet = options.facet.concat(p);
      });

      delete options.selectedParameters;

      options.pageNumber = 1;

      return options;
    },
    extractors: {
      "Price": function (r, options) {
        options.minPrice = selection.price.min;
        options.maxPrice = selection.price.max;
      },
      "Categories": function (r, options) {
        r.selectedSubRefinements().map(function (s) {
          options.categoryId = s.parameter;
        });
      },
      "Customer rating": function (r, options) {
        options.selectedParameters.push( r.selectedSubRefinements().map(function (s) {
          return "adf_f11001%3A%28" + s.stars + "%7B" + s.stars + "+*%7D%29";
        }));
      },
      "Brand": function (r, options) {
        options.selectedParameters.push( r.selectedSubRefinements().map(function (s) {
          return s.parameter;
        }));
      },
      "All": function (r, options) {
        options.selectedParameters.push( r.selectedSubRefinements().map(function (s) {
          return s.parameter;
        }));
      }
    }
  };
});