
/* JavaScript content from js/app/models/selectionDescription.js in folder common */
/*global define*/

define("app/models/selectionDescription", ['app/models/Selection'], function (selection) {

  return {
    "Categories": function () {
      var selected = this.selectedSubRefinements();

      if (selected.length === 1) {
        return selected[0].name;
      }

      return selected.length + " selected";
    },
    "Customer rating": function () {
      var span = document.createElement('SPAN');
      var stars = this.selectedSubRefinements()[0].stars;
      var starsText = " stars";
      var desc = "";

      if (stars === 1) {
        starsText = " star";
      }

      if (stars !== 5) {
        desc = " and up";
      }

      span.innerHTML = stars + starsText + desc;

      return span;
    },
    "Price": function () {
      var min = parseInt(selection.price.min, 10);
      var max = parseInt(selection.price.max, 10);

      if (isNaN(min)) {
        return 'up to £' + max;
      }

      if (isNaN(max)) {
        return '£' + min + ' and up';
      }

      return "£" + min + "-" + max;
    },
    "Brand": function () {
      var selected = this.selectedSubRefinements();

      if (selected.length === 1) {
        return selected[0].name;
      }

      return selected.length + " selected";
    },
    "All": function () {
      var selected = this.selectedSubRefinements();

      if (selected.length === 1) {
        return selected[0].name;
      }

      return selected.length + " selected";
    }
  };
});