
/* JavaScript content from js/app/nativeMethods.js in folder common */
/*global define,window*/
/*jslint unparam:true */

define(function () {
  if (window.cordova) {
    return window.cordova;
  }

  var nativeMethods = {
    Login: {
      loginRequired: function (cbSuccess, cbFailure) {
        window.nativeNavigate('Login');
        cbSuccess();
      },
      loginDidSucceed: function (cbSuccess, cbFailure) {
        window.nativeNavigate('Product', {productId: '1000001'});
        cbSuccess();
      }
    },
    NativeChallengeHandler: {
      authenticate: function (successCb, failureCb, args) {
        var invocationData = {
          adapter : "Customer",
          procedure : "doLogin",
          parameters : args
        };
        require(['app/challengeHandler'], function (challengeHandler) {
          challengeHandler.submitAdapterAuthentication(invocationData, {});
        });
      },
      register: function () {
        return undefined;
      }
    },
    WebProxy: {
      invoke: function (cbSuccess, cbFailure, adapter, method, query) {
        console.warn('not supported off device');
      }
    },
    Refinements: {
      applyRefinements: function () {
        return undefined;
      },
      clearRefinements: function () {
        return undefined;
      },
      cancelRefinementPanel: function () {
        return undefined;
      }
    },
    PageLoadHandler: {
      loaded: function () {
        console.warn('web notified the phone it loaded');
      },
      error: function () {
        console.error('web notified the phone that there was an error loading');
      }
    },
    Analytics: {
      trackValidationError: function () {
        return undefined;
      },
      trackAddToBasket: function () {
        return undefined;
      }
    },
    AddToBasket: {
      addProductToBasket: function () {
        return undefined;
      }
    }
  };

  return {
    exec: function (cbSuccess, cbFailure, pluginName, pluginMethod, arrayOfParams) {
      var plugin = nativeMethods[pluginName];
      plugin[pluginMethod].apply(plugin, [cbSuccess, cbFailure, arrayOfParams]);
    },
    error: function (msg) {
      nativeMethods.PageLoadHandler.error(console.info.bind(console), console.error, [msg]);
    }
  };
});
