
/* JavaScript content from js/app/nativeToWeb.js in folder common */
/*global window*/

(function () {

  var nativeToWebMethods = {
    navigate: function (viewId, params) {
      require(["app/appNavigate"],
        function (appNavigate) {
          appNavigate(viewId, params);
        });
    },
    join: function () {
      require(["dojo/on"],
        function (on) {
          on.emit(document.body, 'register', {
            bubbles: true
          });
        });
    }
  };

  window.nativeToWeb = {};

  Object.keys(nativeToWebMethods).forEach(function (functionName) {
    var fn = nativeToWebMethods[functionName];
    window.nativeToWeb[functionName] = function () {
      var args = arguments;
      require(["dojo/ready", "dojo/on"],
        function (ready, on) {

          var dojoxAppReady = function () {
            // a very large number so that this callback is fired last
            var aimForLowestPriority = 1000000000;
            ready(aimForLowestPriority, function () {
              fn.apply(window.nativeToWeb, args);
            });
          };

          if (window.DOJOX_APP_LOADED) {
            dojoxAppReady();
          } else {
            on(document.body, 'dojox-app-loaded', dojoxAppReady);
          }
        });
    };
  });
}());