
/* JavaScript content from js/app/stores/ProductStore.js in folder common */
/*global define*/

define("app/stores/ProductStore", ["dojo/_base/declare",
  "dojo/request/registry",
  "app/models/Product",
  "app/nativeMethods",
  "app/util/requestProvider/ServiceRegistryRequestProvider"],
  function (declare, request, Product, nativeMethods) {

    function productQuery(query) {
      return request("registry://GET_PRODUCT_INFORMATION", query).then(function (result) {
        try {
          return Product.fromWorklightPayload(result);
        } catch (e) {
          nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'error', ['test']);
          throw e;
        }
      }, function (e) {
        nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'error', ['test']);
        throw e;
      });
    }

    var ProductStore = declare('app/stores/ProductStore', null, {
      query: productQuery
    });

    return new ProductStore();
  });