
/* JavaScript content from js/app/stores/ReviewStoreRest.js in folder common */
/*global define*/
/*jslint unparam: true*/

define([
  "dojo/request/registry",
  "dojo/_base/lang",
  "dojo/_base/declare",
  "dojo/store/util/QueryResults",
  "dojo/Deferred",
  "app/nativeMethods",
  "app/util/requestProvider/ServiceRegistryRequestProvider"],
  function (request, lang, declare, QueryResults, Deferred, nativeMethods) {
    var base = null;

    return declare("dojo.store.JsonRest", base, {
      constructor: function (options) {
        declare.safeMixin(this, options);
      },
      model: {},
      params: {},
      queryKey: "",
      idProperty: "id",
      getIdentity: function (object) {
        return object[this.idProperty];
      },
      query: function (query, options) {
        lang.mixin(this.params, {
          start: (options.start).toString(),
          end: (options.start + options.count).toString()
        });

        var deferred = new Deferred();

        var promise = request("registry://GET_REVIEWS", this.params);

        promise.then(lang.hitch(this, function (response) {
          var results = response.Results;

          results.ReviewsTotal = response.TotalResults;

          deferred.resolve(results);
        }), nativeMethods.error);

        var queryPromise = deferred.promise;

        var finalPromise = lang.delegate(queryPromise, {
          total: queryPromise.then(function (response) {
            return response.ReviewsTotal;
          })
        });

        return new QueryResults(finalPromise);
      }

    });
  });