
/* JavaScript content from js/app/transit.js in folder common */
/*global define*/

/**
 * an AMD module that overrides the dojox/app slide transition for views.
 *
 * @module app/transit
 * @augments dojox/css3/transition
 * @see {@link http://bill.dojotoolkit.org/api/1.9/dojox/css3/transition|transition documentation}
*/
define("app/transit", [
  "dojox/css3/transition"],
  function (Transition) {

    var translateMethodStart = "translate3d(",
      transitionPrefix = "WebkitT",
      translateMethodEnd = ",0,0)",
      refineFirstLoadComplete = false;

    /**
     * The only way to override dojo transitions
     *
     * @method slide
     * @memberof module:app/transit#
     * @param {String} node - The node that the slide transition effect will be applied on.
     * @param {arguments} config - The config arguments which will be mixed into this transition object.
     * @returns {module:dojox/css3/transtion} Returns the transition
    */
    Transition.slide = function (node, config) {

      config.duration = "500"; //overriding default speed of 250

      var transition = new Transition(config),
        startX = "0",
        endX = "0";

      transition.node = node;

      if (transition["in"]) {
        if (transition.direction === 1) {
          if (node.id === 'Homebase_Refine' && !refineFirstLoadComplete) {
            startX = '0%';
          } else {
            startX = "100%";
          }
        } else {
          startX = "-100%";
        }
      } else {
        if (transition.direction === 1) {
          endX = "-100%";
        } else {
          endX = "100%";
        }
      }

      transition.startState[transitionPrefix + "ransform"] = translateMethodStart + startX + translateMethodEnd;
      transition.endState[transitionPrefix + "ransform"] = translateMethodStart + endX + translateMethodEnd;

      return transition;

    };
  });