
/* JavaScript content from js/app/views/Home.js in folder common */
/*global define*/

define("app/views/Home", [
  "dojo/_base/declare",
  "dojo/text!./templates/Home.html",
  "app/presenters/ContentPresenter",
  "dojo/when",
  "dojo/window",
  "./_ViewBase",
  "dojo/query",
  "dojo/dom-construct",
  "dojo/dom-geometry",
  "app/widgets/Espot",
  "app/nativeMethods",
  "dojo/on",
  "dojo/DeferredList",
  "dojo/NodeList-dom"],
  function (declare, templateString, ContentPresenter, when, win, _ViewBase, query, domConstruct, domGeom, Espot, nativeMethods, on, DeferredList) {
    return declare("app/views/Home", [_ViewBase], {
      templateString: templateString,
      init: function () {

        if (navigator.userAgent.match(/Android/i)) {
          query("body").addClass("android");
        }

        var espotWidgets = [],
          deferreds    = [];

        espots = [
          {
            name: 'sa_phone_home_banner',
            height: 48
          },
          {
            name: 'sa_phone_home_a1.1',
            height: 256
          },
          {
            name: 'sa_phone_home_a1.2',
            height: 48
          },
          {
            name: 'sa_tablet_home_banner',
            height: 56
          },
          {
            name: 'sa_tablet_home_a1.1',
            height: 256
          },
          {
            name: 'sa_tablet_home_a1.2',
            height: 256
          },
          {
            name: 'sa_tablet_home_a1.3',
            height: 528
          }
        ];

        var errorCount = 0,
          successCount = 0;

        espots.forEach(function (espot) {
          var c = ContentPresenter.getContent(espot.name),
            espotCount = espots.length;

          deferreds.push(c);
          when(c, function (content) {
            successCount++;
            var widget = new Espot({espot: content, height: espot.height, name: espot.name, env: this.params.WCSURL});
            widget.startup();
            espotWidgets.push(widget);
          }.bind(this), function() {
            errorCount++;
            if (errorCount === espotCount) {
              nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'error', []);
            }
          }.bind(this));
        }.bind(this));

        deferreds = new DeferredList(deferreds);

        deferreds.then(function () {
          espotWidgets.forEach(function (espotWidget) {
            if (espotWidget.name === "sa_phone_home_banner" || espotWidget.name === "sa_tablet_home_banner") {
              this.espot_banner.appendChild(espotWidget.domNode);
            } else if (espotWidget.name === "sa_tablet_home_a1.3") {
              this.espot_left.appendChild(espotWidget.domNode);
            } else if (espotWidget.name === "sa_phone_home_a1.1") {
              this.right_top.appendChild(espotWidget.domNode);
            } else {
              this.right_bottom.appendChild(espotWidget.domNode);
            }
            nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'loaded', []);
          }.bind(this));

        }.bind(this));

        this.pageReady();
      }
    });
  });