
/* JavaScript content from js/app/views/Login.js in folder common */
/*global define*/

define(["dojo/_base/declare",
  "dojo/text!./templates/Login.html",
  "./_StaticViewBase",
  "dojo/dom",
  "dojo/query",
  "dojo/_base/event",
  "dojo/dom-attr",
  "dojo/dom-style",
  "app/views/_Authentication",
  "app/nativeMethods",
  "app/errors/mapping"],
  function (declare, templateString, _ViewBase, dom, query, baseEvent, domAttr, domStyle, _Authentication, nativeMethods, mapping) {
  
  	var emailIsEntered = function(string)	{
  		var email = dom.byId("emailAddress").value;
	  	if (email && email.length > 0) {
		  	return true;
	  	} else return false;
  	}
    var profile = {
      required: ["emailAddress", "password"],
      constraints: {
	     password: emailIsEntered
      },
      messages: {
        emailAddress : {
          field: "emailAddress",
          missing: this.missingMessage + " email address"
        },
        password : {
          field : "password",
          missing: this.missingMessage + " password"
        }
      }
    };

    return declare("app/views/Login", [_Authentication, _ViewBase], {
      templateString: templateString,
      init: function () {
        this.inherited(arguments);
        this.profile = profile;
        this.addClassToBody("login");
      },
      signUp: function (e) {
        baseEvent.stop(e);
        nativeMethods.exec(null, null, 'SignInToRegistration', 'start', [""]);
      },
      formFailedValidation: function (results) {
 
        this.inherited(arguments);
        
        nativeMethods.exec(console.trace, console.trace, 'Analytics', 'trackValidationError', ['Login', this.coreMetricsMessage(results)]);
      },
      showErrors: function (error) {
        var serverErrors = mapping.errors(error),
          passwordField = dom.byId("password"),
          clearIcon = passwordField.nextElementSibling;
        window.scrollTo(0, 0);
        domStyle.set(dom.byId("detailTitle"), 'display', 'none');
        this.detailResultNode.innerHTML = serverErrors.message;
        domAttr.set(passwordField, "value", "");
        clearIcon.style.display = "none";
      },
      _forgotPassword: function(e) {
        baseEvent.stop(e);
        nativeMethods.exec(null, null, 'NativeChallengeHandler', 'forgotPassword', [""]);
      },
      formPassedValidation: function (formData) {
        nativeMethods.exec(console.trace, function(error) { this.showErrors(error); }.bind(this), 'NativeChallengeHandler', 'authenticate', [ formData.emailAddress, formData.password ]);
      }
    });
  });