
/* JavaScript content from js/app/views/Price.js in folder common */
/*global define*/

define("app/views/Price", [
  "dojo/_base/declare",
  "dojo/query",
  "dojo/dom-style",
  "app/views/_RefineBase",
  "dojo/dom",
  "dojo/on",
  "dojo/ready",
  "app/models/Selection",
  "dojo/text!./templates/RefinementView.html"],
  function (declare, query, domStyle, _RefineBase, dom, on, ready, selection, templateString) {
    ready(function () {

      on(window, 'touchstart', function() {
        document.activeElement.blur();
      });

    });
    return declare("app/views/Price", [_RefineBase], {
      templateString: templateString,
      beforeActivate: function () {
        this.inherited(arguments);
        this.loadRefinement();
        this.populate();
        this.populatePrice();
      },
      populatePrice: function () {
        ready(function() {
          var inputs = query('input[type="number"]', this.domNode),
            priceRange = selection.price;

          if (priceRange) {
            if (priceRange.min && !isNaN(priceRange.min)) {
              inputs[0].value = priceRange.min;
            }
            if (priceRange.max && !isNaN(priceRange.max)) {
              inputs[1].value = priceRange.max;
            }
          }
        });
      },
      init: function() {
        this.inherited(arguments);
      },
      afterActivate: function () {
        this.inherited(arguments);
      },
      beforeDeactivate: function () {
        this.inherited(arguments);

        var inputs = query('input[type="number"]', this.domNode);
        selection.set('price', {
          min: parseInt(inputs[0].value, 10),
          max: parseInt(inputs[1].value, 10)
        });

       selection.emit('selection-change', true);

      }
    });
  });