
/* JavaScript content from js/app/views/_RefineBase.js in folder common */
/*global define, navigator, window, history*/

define("app/views/_RefineBase", [
  "dojo/_base/declare",
  "./_ViewBase",
  "app/widgets/Menu",
  "app/models/Refinement",
  "app/models/Selection",
  "app/presenters/RefinePresenter",
  "dojo/dom-style",
  "dojo/dom-attr",
  "dojo/dom-class",
  "dojo/dom",
  "dojo/when",
  "dijit/registry",
  "dojo/_base/lang",
  "dojo/_base/array",
  "dojo/query",
  "dojo/dom-construct",
  "dojo/NodeList-dom",
  "dojox/mobile/ScrollableView"],
  function (declare, _ViewBase, Menu, Refinement, selection, RefinePresenter, domStyle, domAttr, domClass, dom, when, registry, lang, array, query, domConstruct) {
    return declare("app/views/_RefineBase", [_ViewBase], {
      init: function () {
        this.inherited(arguments);
        allMainFacetsDisabled = false;
        this.setupMenu();

        if (navigator.userAgent.match(/Android/i)) {
          query("body").addClass("android");
        }

        if (navigator.userAgent.match(/(iPad)|(iPhone)/i)) {
          query("body").addClass("ios");
        }
      },
      beforeActivate: function (previousView) {
        this.inherited(arguments);
        this.backButtonPending = false;

        this.pageReady();
      },
      beforeDeactivate: function () {
        this.inherited(arguments);
      },
      populate: function (options) {
        this.updateTitle();
        this.menu.populate(this.refinement, options);
      },
      updateTitle: function () {
        this.titleNode.innerHTML = this.refinement.name;
      },
      loadRefinement: function () {
        this.refinement = Refinement.byId[this.params.id];
      },
      setupMenu: function () {
        this.menu = new Menu();
        this.menu.startup();
        this.content.appendChild(this.menu.domNode);
      },
      goBack: function () {
        allMainFacetsDisabled = false;
        this.inherited(arguments);
        if (history && this.backButtonPending === false) {
          this.backButtonPending = true;
          history.go(-1);
        }
        document.activeElement.blur();
      }
    });
  });