
/* JavaScript content from js/app/views/_ViewBase.js in folder common */
/*global define*/

define(["require",
  "dojo/_base/declare",
  "dojox/app/ViewBase",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojox/mobile/TransitionEvent",
  "fastclick/fastclick",
  "dojo/dom-construct",
  "dojo/query",
  "dojo/_base/array",
  "app/nativeMethods"],
  function (require, declare, ViewBase, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, TransitionEvent, FastClick, domConstruct, query, array, nativeMethods) {

    return declare([ _WidgetBase, ViewBase, _TemplatedMixin, _WidgetsInTemplateMixin ], {

      contextRequire: require,

      transition: function (params) {
        new TransitionEvent(this.domNode, params).dispatch();
      },
      afterActivate: function () {
        if (!this.__ready__) {
          this.__display__ = this.domNode.style.display;
          this.domNode.style.display = 'none';
        }
      },
      pageReady: function (response) {
        if (!this.__ready__) {
          this.__ready__ = true;
          this.domNode.style.display = this.__display__ || 'block';
          delete this.__display__;
          if (typeof this.onReady === 'function') {
            this.onReady();
          }
          query(".viewLoader").forEach(domConstruct.destroy);

          var fastclick = this.domNode.querySelectorAll('.fastclick, input, select, label, a, button');

          array.forEach(fastclick, function (fc) {
            var fclick = new FastClick(fc);
            return fclick;
          });

          if (response) {
            nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'loaded', [ response.wlResponse ]);
          } else {
            nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'loaded', []);
          }
        }
      },
      error: function (msg) {
        nativeMethods.exec(console.info.bind(console), console.error, 'PageLoadHandler', 'error', [msg]);
      }
    });
  });