
/* JavaScript content from js/app/widgets/Menu.js in folder common */
/*global define*/

define("app/widgets/Menu", [
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/Menu.html",
  "app/widgets/MenuSection"],
  function (declare, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, MenuSection) {
    return declare("Menu", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      section3Visisble: function () {
        return this.refinement.showExtraRefinements || this.refinement.categoriesRefinement() && this.refinement.isRoot() && this.refinement.categoriesRefinement().hasSubSelection();
      },
      buildSections: function () {
        var sections = [];

        if (this.refinement.isRoot()) {
          var section1 = [],
              section2 = [],
              section3 = [];

          this.refinement.refinements.forEach(function (topLevelRefinement) {
            var section;

            switch(topLevelRefinement.title) {
              case 'Categories':
                section = section1;
                break;
              case 'Price':
              case 'Rating':
              case 'Brand':
                section = section2;
                break;
              default:
                section = section3;
            }

            section.push(topLevelRefinement);
          });


          if (this.section3Visisble() ) {
            sections.push(section1, section2, section3);
          } else {
            sections.push(section1, section2);
          }
        } else {
          sections.push(this.refinement.refinements);
        }

        return sections;
      },
      populate: function (refinement, options) {
        this.refinement = refinement;

        this.clearAll();

        var sections = this.buildSections();

        sections.forEach(function (section, index) {
          var menuSectionWidget = new MenuSection({
            section: section,
            refinement: refinement,
            index: index,
            options: options
          });
          menuSectionWidget.startup();
          this.domNode.appendChild(menuSectionWidget.domNode);
        }.bind(this));
      },
      clearAll: function () {
        while (this.domNode.hasChildNodes() && this.domNode.firstChild) {
          this.domNode.removeChild(this.domNode.firstChild);
        }
      },
      isPopulated: function () {
        return this.refinement;
      }
    });
  });
