
/* JavaScript content from js/app/widgets/ProductReview.js in folder common */
/*global define*/

define(["dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/ProductReview.html",
  "app/widgets/_Review",
  "app/widgets/SecondaryRating"],
  function (declare, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, _Review, SecondaryRating) {
    return declare("app/widgets/Review", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _Review], {
      templateString: templateString,
      _setAverageRatingAttr: function (AverageRating) {
        this.averageRating.setRating(AverageRating);
      },
      _setPositiveFeedbackCountAttr: {
        node: "_positiveFeedbackNode",
        type: "innerHTML"
      },
      _setNegativeFeedbackCountAttr: {
        node: "_negativeFeedbackNode",
        type: "innerHTML"
      },
      _setSecondaryRatingsAttr: function (SecondaryRatings) {
        var secondaryRating,
          index;

        for (index in SecondaryRatings) {
          if (SecondaryRatings.hasOwnProperty(index)) {
            secondaryRating = new SecondaryRating();
            secondaryRating.set('data', SecondaryRatings[index]);
            secondaryRating.placeAt(this._secondaryRatings, "last");
          }
        }
      },
      _setDataAttr : function (_data) {
        this.inherited(arguments);

        this.set("PositiveFeedbackCount", _data.TotalPositiveFeedbackCount);
        this.set("NegativeFeedbackCount", _data.TotalNegativeFeedbackCount);
        this.set("SecondaryRatings", _data.SecondaryRatings);
      }
    });
  });