
/* JavaScript content from js/app/widgets/RecommendedProduct.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dojo/_base/array",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "app/widgets/_Product",
  "dojo/text!./templates/Product.html",
  "app/nativeMethods",
  "dojo/dom-style",
  "app/widgets/_ImageButton"],
  function (declare, _WidgetBase, array, _TemplatedMixin, _WidgetsInTemplateMixin, _Product, templateString, nativeMethods, domStyle, ImageButton) {
    return declare("app/widgets/RecommendedProduct", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _Product], {
      templateString: templateString,
      _setDataAttr : function (_data) {
        this.inherited(arguments);

        var description = this._data.name,
          image = this._data.imageURL,
          rating = this._data.rating,
          numberOfReviews = this._data.numReviews,
          price = this._data.priceCents,
          wasPrice = this._data.wasPrice,
          savePrice = this._data.savePrice;


        if (description) {
          this.set("Description", description);
        } else {
          domStyle.set(this._desc, 'display', 'none');
        }

        if (image) {
          this.set("Thumbnail", "http:" + image);
        } else {
          domStyle.set(this._image, 'display', 'none');
        }

        if (rating && rating !== -1) {
          this.set("AverageRating", rating);
        } else {
          domStyle.set(this._rating, 'display', 'none');
        }

        if (numberOfReviews) {
          this.set("ReviewCount", numberOfReviews);
        }

        if (price) {
          this.set("Price", price);
        }

        if (wasPrice) {
          this.set("wasPrice", wasPrice);
        }

        if (savePrice) {
          this.set("SavingsMessage", savePrice);
        }
      },
      _navigateToProductPage: function () {
        nativeMethods.exec(null, null, 'FireOnClickURL', 'fireOnClickURL', [this._data.clickURL]);
        this.inherited(arguments);
      }
    });
  });