
/* JavaScript content from js/app/widgets/RelatedProduct.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dojo/_base/lang",
  "dojo/_base/array",
  "dojo/text!./templates/RelatedProduct.html",
  "dojo/dom-style",
  "dojo/query",
  "dojo/window",
  "dojo/dom-class",
  "app/widgets/Product",
  "app/widgets/RecommendedProduct"],
  function (declare, _WidgetBase, _TemplatedMixin, lang, array, templateString, domStyle, query, win, domClass, Product, RecommendedProduct) {
    return declare("app/widgets/RelatedProduct", [_WidgetBase, _TemplatedMixin], {
      templateString: templateString,
      startup: function () {
        var params = this.params,
          relatedProductsExist = query('.product-list').length,
          i = 1;

        array.forEach(params.products, lang.hitch(this, function (product) {
          if (product.name) {
            if (this.params.type === "recommendation") {
              var productWidget = new RecommendedProduct();
            } else {
              var productWidget = new Product();
            }
            productWidget.set('data', product);

            productWidget.placeAt(this.essentialExtras, "last");
            productWidget.startup();

            this.index = i++;
          }
        }));

        if (!this.index) {
          domStyle.set(this.domNode, 'display', 'none');
        } else {
          var productWidth = query(".product").style("width");
          domStyle.set(this.essentialExtras, "width", this.index * productWidth[0] + "px");
        }

        if (relatedProductsExist) {
          domClass.remove(query('.product-list')[0], 'closed');
        }
      },
      _toggleRelatedProducts: function (e) {
        var target = e.currentTarget;
        domClass.toggle(target.parentElement, "closed");
        win.scrollIntoView(this.domNode);
      }
    });
  });