
/* JavaScript content from js/app/widgets/RelatedProducts.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dojo/dom-style",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/RelatedProducts.html",
  "app/widgets/RelatedProduct"],
  function (declare, _WidgetBase, domStyle, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, RelatedProduct) {
    return declare("app/widgets/RelatedProducts", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      setRelatedProducts: function (params) {
        var relatedProduct = new RelatedProduct({ 'products' : params.products, 'title' : params.title, 'type' : params.type });
        relatedProduct.placeAt(this.products, "last");
        domStyle.set(this.loader, 'display', 'none');
      },
      setAlsoInRange: function (products) {
        this.setRelatedProducts({products: products, title: "Also in this range" });
      },
      setEssentialExtras: function (products) {
        this.setRelatedProducts({products: products, title: "Essential extras" });
      },
      setAlternatives: function (products) {
        this.setRelatedProducts({products: products, title: "Alternatives" });
      },
      buildPlacements: function (placements) {
        for (var i = 0; i < placements.length; i++) {
          var placement = placements[i];

          this.setRelatedProducts({products: placement.recommendedProducts, title: placement.strategyMessage, type: "recommendation"});
        }
      }
    });
  });