
/* JavaScript content from js/app/widgets/Reviews.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/_base/lang",
  "app/nativeMethods",
  "dojo/dom-style",
  "dojo/_base/array",
  "dojo/text!./templates/Reviews.html",
  "app/widgets/Review"],
  function (declare, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, lang, nativeMethods, domStyle, array, templateString, Review) {
    return declare("app/widgets/Reviews", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      postCreate: function () {
        var params = this.params,
          count = 0;

        if (params.Reviews.length >= 1) {
          array.forEach(params.Reviews, lang.hitch(this, function (_review) {
            count++;
            array.some(params.Reviews, function () {
              if (count >= 4) {
                return false;
              }
              count++;
            });
            var review = new Review();
            review.set('data', _review);
            review.placeAt(this.reviews, "last");
            review.startup();
          }));
        }
      },
      _loadReviewsPage: function (event) {
        event.preventDefault();
        nativeMethods.exec(null, null, 'PDPReviews', 'start', [this.params.Product.id]);
      },
      _setAverageRatingAttr: function (AverageRating) {
        if (AverageRating) {
          this.averageRatingMiddle.setRating(AverageRating);
        } else {
          this._hideDomNode(this.rating);
        }
      },
      _setRatingCountAttr: function (RatingCount) {
        if (RatingCount) {
          this.reviewCount.innerHTML = RatingCount;
          this.reviewCountBottom.innerHTML = RatingCount;
        } else {
          this._hideDomNode(this.reviewCount);
        }
      },
      _setDataAttr : function (_data) {
        this.set("AverageRating", _data.averageRating);
        this.set("RatingCount", _data.numberOfRatings);
      },
      _hideDomNode: function (node) {
        domStyle.set(node, 'display', 'none');
      }
    });
  });