
/* JavaScript content from js/app/widgets/ReviewsContainer.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/ReviewsContainer.html",
  "dojo/dom-style"],
  function (declare, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, domStyle) {
    return declare("app/widgets/ReviewsContainer", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      _setIDAttr: {
        node: "_idNode",
        type: "innerHTML"
      },
      _setNameAttr: {
        node: "_nameNode",
        type: "innerHTML"
      },
      _setDataAttr : function (_data) {
        this.set("ID", _data.id);
        this.set("Name", _data.name);
        if (_data.averageRating) {
          this.set("AverageRating", _data.averageRating);
          this.set("RatingCount", _data.numberOfRatings);
        } else {
          this._hideDomNode(this.rating);
        }
      },
      _setAverageRatingAttr: function (averageRating) {
        this.ratingTop.setRating(averageRating);
      },
      _setRatingCountAttr: function (ratingCount) {
        this.reviewCountTop.innerHTML = ratingCount;
      },
      _hideDomNode: function (node) {
        domStyle.set(node, 'display', 'none');
      }
    });
  });