
/* JavaScript content from js/app/widgets/_Product.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dojo/_base/array",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/Product.html",
  "app/nativeMethods",
  "dojo/dom-style",
  "app/widgets/_ImageButton"],
  function (declare, _WidgetBase, array, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, nativeMethods, domStyle, ImageButton) {
    return declare("app/widgets/_Product", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      _setThumbnailAttr: function (thumbnail) {
        var imageButton = new ImageButton();
        imageButton.set('imageUrl', thumbnail + "?wid=320&hei=320");
        imageButton.set('ariaLabel', this._data.description);
        imageButton.placeAt(this.scroller, "last");
        imageButton.startup();
      },
      _setDescriptionAttr: {
        node: "_desc",
        type: "innerHTML"
      },
      _setPriceAttr: function (price) {
        this._price.innerHTML = "&pound;" + price;
      },
      _setReviewCountAttr: {
        node: "reviewCountNode",
        type: "innerHTML"
      },
      _setWasPriceAttr: function (wasPrice) {
        this._wasPrice.innerHTML = "Was £" + wasPrice;
      },
      _setSavingsMessageAttr: {
        node: "_savingText",
        type: "innerHTML"
      },
      _setAverageRatingAttr: function (AverageRating) {
        this.averageRating.setRating(AverageRating);
      },
      _setReviewCountAttr: function (reviewCount) {
        this.reviewCountNode.innerHTML = reviewCount;
      },
      _data : null,
      _setDataAttr : function (_data) {
        this._data = _data;
      },
      _getDataAttr : function () {
        return this._data;
      },
      _navigateToProductPage: function () {
        nativeMethods.exec(null, null, 'OpenRelatedProduct', 'start', [{
          page: 'Product',
          productName: this._data.name,
          id: this._data.id
        }]);
      }
    });
  });