
/* JavaScript content from js/app/widgets/_Review.js in folder common */
/*global define*/

define(["dojo/_base/declare",
  "dojo/date/locale",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dojo/text!./templates/Review.html",
  "dojo/dom-class",
  "dojo/dom-style"],
  function (declare, locale, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, templateString, domClass, domStyle) {
    return declare("app/widgets/Review", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      _setTitleAttr: {
        node: "_title",
        type: "innerHTML"
      },
      _setAuthorAttr: function(author) {
        if (author) {
          this._author.innerHTML = author;
        } else {
          this._author.innerHTML = "Anonymous";
        }
      },
      _setTextAttr: function (text) {
        this._text.innerHTML = text;
      },
      _setDateAttr: {
        node: "_date",
        type: "innerHTML"
      },
      _setAverageRatingAttr: function (AverageRating) {
        this.averageRating.setRating(AverageRating);
      },
      _formatDate: function (date, format) {
        return locale.format(date, {selector: "date", datePattern: format});
      },
      _setDataAttr : function (_data) {
        var date = new Date(_data.SubmissionTime);
        var format = "dd MMM y";

        this.set("Title", _data.Title);
        this.set("Author", _data.UserNickname);
        this.set("Text", _data.ReviewText);
        this.set("Date", this._formatDate(date, format));
        this.set("AverageRating", _data.Rating);
      },
      _getDataAttr : function () {
        return this._data;
      },
      _toggleMore: function (e) {
        e.currentTarget.innerHTML = "less";
        domClass.toggle(this.textNode, "closed open");
        domClass.toggle(e.currentTarget, "more less");
        e.preventDefault();
        if (domClass.contains(e.currentTarget, "less")) {
          e.currentTarget.innerHTML = "less";
        } else {
          e.currentTarget.innerHTML = "more";
        }
      }
    });
  });