
/* JavaScript content from js/app/widgets/menu-item/Refinement.js in folder common */
/*global define,window*/

define(["dojo/_base/declare",
  "app/appNavigate",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "app/models/Selection",
  "dojo/dom-style",
  "dojo/query",
  "dojo/_base/array",
  "dojo/on",
  "dojo/dom-class",
  "dojo/dom-attr",
  "dojo/text!./templates/Refinement.html"],
  function (declare, appNavigate, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, selection, domStyle, query, array, on, domClass, domAttr, templateString) {
    return declare("app/widgets/menu-item/Refinement", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
      templateString: templateString,
      startup: function () {
        this.inherited(arguments);

        var refinement = this.params.refinement;
        this.text.innerText = refinement.name;

        this.on('click', function (e) {
          if (e.currentTarget.classList.contains('clicked')) {
            return;
          } else {
            array.forEach(query('.topLevel .refinement'), function(link) {
              domClass.add(link, 'clicked');
            });
            if (allMainFacetsDisabled === true) {
              return;
            }
            allMainFacetsDisabled = true;
            if (refinement.subview) {
              appNavigate(refinement.subview, { id: refinement.id() });
              array.forEach(query('.topLevel .refinement'), function(link) {
                setTimeout(function() {
                  domClass.remove(link, 'clicked');
                }, 1000);
              });
            }
          }
        }.bind(this));

        selection.on('selection-change', function (r, newValue) {
          this.updateSelectionDescription(newValue);
        }.bind(this));

        this.updateSelectionDescription();
      },
      updateSelectionDescription: function () {
        var refinement = this.refinement;

        var selectionDescription = refinement.selectionDescription();
        if (typeof selectionDescription === 'object') {
          while (this.selectionDescription.hasChildNodes()) {
            this.selectionDescription.removeChild(this.selectionDescription.firstChild);
          }
          this.selectionDescription.appendChild(selectionDescription);
        } else {
          this.selectionDescription.innerText = selectionDescription;
        }

        if (refinement.hasSubSelection()) {
          this.selectionDescription.classList.add('selected');
        } else {
          this.selectionDescription.classList.remove('selected');
        }
      }
    });
  });