
/* JavaScript content from js/app/widgets/menu-item/_LeafItem.js in folder common */
/*global define*/

define([
  "dojo/_base/declare",
  "dojo/query",
  "dojo/_base/array",
  "app/models/Selection",
  "dojo/NodeList-dom",
  "dojo/NodeList-traverse"],
  function (declare, query, array, selection) {

    return declare("app/widgets/menu-item/_LeafItem", [], {
      startup: function () {
        this.inherited(arguments);

        this.on('click', function () {
          this.refinement.toggleSelection();
        }.bind(this));

        selection.on('selection-change', function (refinement, newVal) {
          if (refinement === this.refinement) {
            this.updateSelectedState(newVal);
          }
        }.bind(this));

        this.updateSelectedState(this.refinement.isSelected());
      },
      updateSelectedState: function (selected) {
        if (selected) {
          this.domNode.classList.add('selected');
        } else {
          this.domNode.classList.remove('selected');
        }
      }
    });
  });